-- Designed by Toshio Iwata at DIGITALFILTER.COM 2015/09/22

library IEEE;
use IEEE.std_logic_1164.all;

entity fulladd4dvi is
	port ( A, B, CIN : in std_logic;
	SUM, COUT : out std_logic );
end fulladd4dvi ;

architecture STRUCTURE of fulladd4dvi is

component halfadd4dvi 
	port ( A, B : in std_logic;
	S, C : out std_logic );
end component;

signal C1_C, C1_S, C2_C : std_logic;
begin
	COMP1 : halfadd4dvi port map ( A, B, C1_S, C1_C );
	COMP2 : halfadd4dvi port map ( C1_S, CIN, SUM, C2_C );
	COUT <= C1_C or C2_C;
end STRUCTURE;